# knife list

The knife list subcommand is used to view a list of objects on the Chef server. This subcommand works similar to `knife cookbook list`, `knife data bag list`, `knife environment list`, `knife node list`, and `knife role list`, but with a single verb (and a single action).

## Syntax

This subcommand has the following syntax:

    $ knife list [PATTERN...] (options)

## Options

Note

Review the list of common options available to this (and all) knife subcommands and plugins.

This subcommand has the following options:

`-1`
  Use to show only one column of results. Default: `false`.
`--chef-repo-path PATH`
  The path to the chef-repo. This setting will override the default path to the chef-repo. Default: same value as specified by `chef_repo_path` in client.rb.
`--concurrency`
  The number of allowed concurrent connections. Default: `10`.
`-d`
  Use to prevent a directory’s children from showing when a directory matches a pattern. Default value: `false`.
`-f`, `--flat`
  Use to show a list of file names. Set to `false` to view ls-like output. Default: `false`.
`--local`
  Use to return only the contents of the local directory. Default: `false`.
`-p`
  Use to show directories with trailing slashes (/). Default: `false`.
`-R`
  Use to list directories recursively. Default: `false`.
`--repo-mode MODE`
  The layout of the local chef-repo. Possible values: `static`, `everything`, or `hosted_everything`. Use `static` for just roles, environments, cookbooks, and data bags. By default, `everything` and `hosted_everything` are dynamically selected depending on the server type. Default: `everything` / `hosted_everything`.

## Examples

The following examples show how to use this knife subcommand:

List roles

For example, to view a list of roles on the Chef server:

    $ knife list roles/

List roles and environments

To view a list of roles and environments on the Chef server:

    $ knife list roles/ environments/

List everything

To view a list of absolutely everything on the Chef server:

    $ knife list -R /